function val = gavalpie(sol)
%evaluation function
global prob;
global tinc;
global spec;
global little;
global posneg;
global numvills;
global cmats;
global cmat3;
global cmat3_2gp;
global only2gp;
global indexmat;
global byvil;
global selection;

b1 = posneg;
b2 = sol(1);
count = 0;

for i=1:numvills-1
if selection(i)
    
    numA = spec(i,1);
    numB = spec(i,2); numBm1 = numB-1;
    rangeA = 1:numA; rangeB = 6:(numB+5);

    grupAprob = prob(i,rangeA);
    grupBprob = prob(i,rangeB);
    grupAtinc = tinc(i,rangeA);
    grupBtinc = tinc(i,rangeB);

    probdata = [grupAprob grupBprob];
    tincdata = [grupAtinc grupBtinc];
    tincvar  = var(tincdata,1);
    
    pipjAterm = 0;
    pipjBterm = 0;
    for j=1:numBm1
    for k=j+1:numB
        if k<=numA
              pipjAterm =   pipjAterm +  grupAprob(j)*grupAprob(k);
        end
              pipjBterm =   pipjBterm +  grupBprob(j)*grupBprob(k);
    end
    end
    tincABbtw = [mean(grupAtinc)*ones(1,numA) mean(grupBtinc)*ones(1,numB)];
    tincABterm = var(tincABbtw,1)/tincvar;
    

    if numA==numB
        wts = 2;
    else
        wts = 1;
    end
    combs = nchoosek(numA+numB,numA)/wts -1;
        
    thiscmat = cmats(:,:,indexmat(numA,numB));
    indsA = [1:numA]; 
    indsB = [numA+1:numA+numB];

    for n=1:combs
        theseindsA = thiscmat(n,indsA);
        theseindsB = thiscmat(n,indsB);
        
        grupApprob = probdata(theseindsA);
        grupBpprob = probdata(theseindsB);
        grupAptinc = tincdata(theseindsA);
        grupBptinc = tincdata(theseindsB);

        pipjApterm = 0;
        pipjBpterm = 0;
        for j=1:numBm1
        for k=j+1:numB
            if k<=numA
                pipjApterm = pipjApterm + grupApprob(j)*grupApprob(k);
            end
                pipjBpterm = pipjBpterm + grupBpprob(j)*grupBpprob(k);
        end
        end
        tincABpbtw = [mean(grupAptinc)*ones(1,numA) mean(grupBptinc)*ones(1,numB)];
        tincABpterm = var(tincABpbtw,1)/tincvar;

        diff =b1*( (pipjAterm-pipjApterm)/(numA-1) + (pipjBterm-pipjBpterm)/(numB-1) ) + ...
              b2*( tincABterm - tincABpterm );
        if diff > little
            if byvil
                count = count + 1/combs;
            else
                count = count + wts;
            end
        end
    end
end
end

i=numvills;
if selection(i)
    
numA = spec(i,1);
numB = spec(i,2);
numC = spec(i,3); numCm1 = numC-1;
rangeA = 1:numA; rangeB = 6:(numB+5); rangeC = 11:(numC+10);

grupAprob = prob(i,rangeA);
grupBprob = prob(i,rangeB);
grupCprob = prob(i,rangeC);
grupAtinc = tinc(i,rangeA);
grupBtinc = tinc(i,rangeB);
grupCtinc = tinc(i,rangeC);

probdata = [grupAprob grupBprob grupCprob];
tincdata = [grupAtinc grupBtinc grupCtinc];
tincvar  = var(tincdata,1);

pipjAterm = 0;
pipjBterm = 0;
pipjCterm = 0;
for j=1:numCm1
for k=j+1:numC
    if k<=numB
    if k<=numA
          pipjAterm =   pipjAterm +  grupAprob(j)*grupAprob(k);
    end
          pipjBterm =   pipjBterm +  grupBprob(j)*grupBprob(k);
    end
          pipjCterm =   pipjCterm +  grupCprob(j)*grupCprob(k);
end
end
tincABCbtw = [mean(grupAtinc)*ones(1,numA) ...
    mean(grupBtinc)*ones(1,numB) mean(grupCtinc)*ones(1,numC)];
tincABCterm = var(tincABCbtw,1)/tincvar;


combs = nchoosek(numA+numB+numC,numC)*nchoosek(numA+numB,numA) -1;
combs2gp = nchoosek(numA+numB,numA) + nchoosek(numA+numC,numA) + nchoosek(numB+numC,numB) -3;

indsA = [1:numA]; 
indsB = [numA+1:numA+numB];
indsC = [numA+numB+1:numA+numB+numC];
    
for n=1:combs
if (cmat3_2gp(n) || ~only2gp)
    
    theseindsA = cmat3(n,indsA);
    theseindsB = cmat3(n,indsB);
    theseindsC = cmat3(n,indsC);

    grupApprob = probdata(theseindsA);
    grupBpprob = probdata(theseindsB);
    grupCpprob = probdata(theseindsC);
    grupAptinc = tincdata(theseindsA);
    grupBptinc = tincdata(theseindsB);
    grupCptinc = tincdata(theseindsC);

    pipjApterm = 0;
    pipjBpterm = 0;
    pipjCpterm = 0;
    for j=1:numCm1
    for k=j+1:numC
        if k<=numB
        if k<=numA
              pipjApterm =   pipjApterm +  grupApprob(j)*grupApprob(k);
        end
              pipjBpterm =   pipjBpterm +  grupBpprob(j)*grupBpprob(k);
        end
              pipjCpterm =   pipjCpterm +  grupCpprob(j)*grupCpprob(k);
    end
    end
    tincABCpbtw = [mean(grupAptinc)*ones(1,numA) mean(grupBptinc)*ones(1,numB) mean(grupCptinc)*ones(1,numC)];
    tincABCpterm = var(tincABCpbtw,1)/tincvar;

    diff =b1*( (  pipjAterm-  pipjApterm)/(numA-1) + (  pipjBterm-  pipjBpterm)/(numB-1) + (  pipjCterm-  pipjCpterm)/(numC-1) ) + ...
          b2*( tincABCterm - tincABCpterm );

    if diff > little
        if byvil
            if only2gp
                count = count + 1/combs2gp;
            else
                count = count + 1/combs;
            end
        else
            count = count + 1;
        end
    end
end
end
end

val=-count;