function [thiscdf keypoints] = getcdf(less,notgreater,wts);

keypoints = sort([less; notgreater]);
numkeypoints = sum(~isnan(keypoints));
keypoints(numkeypoints+1:length(keypoints))=[];

thispdf  = zeros(numkeypoints,1);
thislength  = zeros(numkeypoints,1);
for k=2:numkeypoints
    thispdf(k)  = getpdf(keypoints(k-1:k),less,notgreater,wts);
    thislength(k) = (keypoints(k)-keypoints(k-1));
end
thiscdf = cumsum(thispdf.*thislength);