function c=getinequality3(datalist, datareports, villagenums, twogrups, stats, permprog, numdata, equalerr)
%get the inequality and percentile, -99 will be coded as NaN
[rows,cols]=size(datalist);
for j=1:rows
    for k=1:cols
        if datalist(j,k)==-99,
            datalist(j,k)=NaN; 
        end
    end
end
% Sort by rows, each row corresponding to a group
datalist = sort(datalist,2);

mindata =2;   
numpair = sum(twogrups)/2 +1;
numstats = length(find(stats));
warning off;
results = zeros(numpair,numdata*numstats+3)/0;
village = zeros(numpair,1)/0;
warning on;

k=1;
pair=1;
flag3=0;
while k<=rows
    if twogrups(k)==1 || villagenums(k)==492624543
        if twogrups(k)==1
            numa = datareports(k);
            numb = datareports(k+1);
            grupnums = [numa; numb];
            datagrupa = datalist(k,1:numa)';
            datagrupb = datalist(k+1,1:numb)';
            datatotal = [datagrupa; datagrupb];
            datatotal = equalerr*round(datatotal/equalerr);
        elseif villagenums(k)==492624543
            numa = datareports(k);
            numb = datareports(k+1);
            numc = datareports(k+2);
            grupnums = [numa; numb; numc];
            datagrupa = datalist(k,1:numa)';
            datagrupb = datalist(k+1,1:numb)';
            datagrupc = datalist(k+2,1:numc)';
            datatotal = [datagrupa; datagrupb; datagrupc];
            datatotal = equalerr*round(datatotal/equalerr);
        else error('Something off.');
        end


        notidentical = (max(datatotal) > min(datatotal));
        if notidentical && min(grupnums)>=mindata

%            ['Fine:' num2str(villagenums(k))]
            
            thisresult = geteq3(datatotal,grupnums,stats);%This gets observed grouping results
command = ['thiscompare = ' permprog '(datatotal,grupnums,thisresult,stats,equalerr);'];%This gets results of all permutations
            eval(command);
            
            variance = var(sort(datatotal),1);
            average  = mean(sort(datatotal),1);
            fractionalization = fract(datatotal);
            
            results(pair,1:numdata*numstats) = reshape([thisresult thiscompare]',1,numdata*numstats);
            results(pair,numdata*numstats+1:numdata*numstats+3) = [variance average fractionalization];
            
%        elseif ~notidentical
%            ['Deleted, identical:' num2str(villagenums(k))]
%        else ['Deleted, insufficient data:' num2str(villagenums(k))]
        end
        village(pair) = villagenums(k);
        if twogrups(k)==1
            k=k+2;
        elseif villagenums(k)==492624543
            k=k+3;
            pair3 = pair;
        end
        pair=pair+1;
   else
        k=k+1;
   end
end

%error('Stop')

c= [results village];

line3 = c(pair3,:);
c(pair3,:) = [];
c= [c; line3];