clear all

varshort = 'wst';
varname  = 'Worst-Year';

datafile = strcat('data\resurvey',varshort,'.mat');
resultfile = strcat('results\result',varshort,'plus.mat');%Plus

permprog = 'getrbstdumwtplus';%Plus
numdata = 10;%Plus
equalerr = 10^(-14);

kendtau = 0;
spearho = 0;
vardcmp = 0;
meandif = 0;
pipjs   = 0;
pipjsd1 = 0;
pipjsd2 = 0;
frcdcmp = 0;
avgmansam = 1;
avggrpsam = 0;
chisq = 1;
difij   = 0;
difijd1 = 0;
difijd2 = 0;
pcov = 0;

parmstrings = char(datafile,permprog,varname);
stats = [kendtau spearho vardcmp meandif pipjs pipjsd1 pipjsd2 frcdcmp avgmansam avggrpsam chisq difij difijd1 difijd2 pcov]';

output = runresurvvar(parmstrings,stats,numdata,equalerr);

save(resultfile,'parmstrings','stats','numdata','equalerr','output');