function val = gavalpotst(sol)
%evaluation function
global prob;
global occ;
global spec;
global little;
global posneg;
global numvills;
global cmats;
global cmat3;
global cmat3_2gp;
global only2gp;
global indexmat;
global byvil;
global selection;

b1 = posneg;
b2 = sol(1);
count = 0;
counttotal=0;

for i=1:numvills-1
if selection(i)
   
    numA = spec(i,1);
    numB = spec(i,2); numBm1 = numB-1;
    rangeA = 1:numA; rangeB = 6:(numB+5);

    grupAprob = prob(i,rangeA);
    grupBprob = prob(i,rangeB);
    grupAocc  = permute(occ(i,rangeA,:),[3 2 1]);
    grupBocc  = permute(occ(i,rangeB,:),[3 2 1]);

    probdata = [grupAprob grupBprob];
     occdata = [grupAocc  grupBocc ];

      pipjAterm = 0;
      pipjBterm = 0;
    occsimAterm = 0;
    occsimBterm = 0;
    for j=1:numBm1
    for k=j+1:numB
        if k<=numA
              pipjAterm =   pipjAterm +         grupAprob(j) *grupAprob(k);
            occsimAterm = occsimAterm - sum(abs(grupAocc(:,j)-grupAocc(:,k)));
        end
              pipjBterm =   pipjBterm +         grupBprob(j) *grupBprob(k);
            occsimBterm = occsimBterm - sum(abs(grupBocc(:,j)-grupBocc(:,k)));
    end
    end


    if numA==numB
        wts = 2;
    else
        wts = 1;
    end
    combs = nchoosek(numA+numB,numA)/wts -1;
        
    thiscmat = cmats(:,:,indexmat(numA,numB));
    indsA = [1:numA]; 
    indsB = [numA+1:numA+numB];

    for n=1:combs
        theseindsA = thiscmat(n,indsA);
        theseindsB = thiscmat(n,indsB);
        
        grupApprob = probdata(theseindsA);
        grupBpprob = probdata(theseindsB);
        grupApocc  =  occdata(:,theseindsA);
        grupBpocc  =  occdata(:,theseindsB);

          pipjApterm = 0;
          pipjBpterm = 0;
        occsimApterm = 0;
        occsimBpterm = 0;
        for j=1:numBm1
        for k=j+1:numB
            if k<=numA
                  pipjApterm =   pipjApterm +         grupApprob(j) *grupApprob(k);
                occsimApterm = occsimApterm - sum(abs(grupApocc(:,j)-grupApocc(:,k)));
            end
                  pipjBpterm =   pipjBpterm +         grupBpprob(j) *grupBpprob(k);
                occsimBpterm = occsimBpterm - sum(abs(grupBpocc(:,j)-grupBpocc(:,k)));
        end
        end

        diff =b1*( (  pipjAterm-  pipjApterm)/(numA-1) + (  pipjBterm-  pipjBpterm)/(numB-1) ) + ...
              b2*( (occsimAterm-occsimApterm)/(numA-1) + (occsimBterm-occsimBpterm)/(numB-1) );
        if diff > little
            if byvil
                count = count + 1/combs;
            else
                count = count + wts;
            end
        end
        if byvil
            counttotal = counttotal + 1/combs;
        else
            counttotal = counttotal + wts;
        end
        
    end
%    count
end
end

i=numvills;
if selection(i)

numA = spec(i,1);
numB = spec(i,2);
numC = spec(i,3); numCm1 = numC-1;
rangeA = 1:numA; rangeB = 6:(numB+5); rangeC = 11:(numC+10);

grupAprob = prob(i,rangeA);
grupBprob = prob(i,rangeB);
grupCprob = prob(i,rangeC);
grupAocc  = permute(occ(i,rangeA,:),[3 2 1]);
grupBocc  = permute(occ(i,rangeB,:),[3 2 1]);
grupCocc  = permute(occ(i,rangeC,:),[3 2 1]);

probdata = [grupAprob grupBprob grupCprob];
 occdata = [grupAocc  grupBocc  grupCocc ];

  pipjAterm = 0;
  pipjBterm = 0;
  pipjCterm = 0;
occsimAterm = 0;
occsimBterm = 0;
occsimCterm = 0;
for j=1:numCm1
for k=j+1:numC
    if k<=numB
    if k<=numA
          pipjAterm =   pipjAterm +         grupAprob(j) *grupAprob(k);
        occsimAterm = occsimAterm - sum(abs(grupAocc(:,j)-grupAocc(:,k)));
    end
          pipjBterm =   pipjBterm +         grupBprob(j) *grupBprob(k);
        occsimBterm = occsimBterm - sum(abs(grupBocc(:,j)-grupBocc(:,k)));
    end
          pipjCterm =   pipjCterm +         grupCprob(j) *grupCprob(k);
        occsimCterm = occsimCterm - sum(abs(grupCocc(:,j)-grupCocc(:,k)));
end
end


combs = nchoosek(numA+numB+numC,numC)*nchoosek(numA+numB,numA) -1;
combs2gp = nchoosek(numA+numB,numA) + nchoosek(numA+numC,numA) + nchoosek(numB+numC,numB) -3;
        
indsA = [1:numA]; 
indsB = [numA+1:numA+numB];
indsC = [numA+numB+1:numA+numB+numC];
    
for n=1:combs
if (cmat3_2gp(n) || ~only2gp)
    
    theseindsA = cmat3(n,indsA);
    theseindsB = cmat3(n,indsB);
    theseindsC = cmat3(n,indsC);

    grupApprob = probdata(theseindsA);
    grupBpprob = probdata(theseindsB);
    grupCpprob = probdata(theseindsC);
    grupApocc  =  occdata(:,theseindsA);
    grupBpocc  =  occdata(:,theseindsB);
    grupCpocc  =  occdata(:,theseindsC);

      pipjApterm = 0;
      pipjBpterm = 0;
      pipjCpterm = 0;
    occsimApterm = 0;
    occsimBpterm = 0;
    occsimCpterm = 0;
    for j=1:numCm1
    for k=j+1:numC
        if k<=numB
        if k<=numA
              pipjApterm =   pipjApterm +         grupApprob(j) *grupApprob(k);
            occsimApterm = occsimApterm - sum(abs(grupApocc(:,j)-grupApocc(:,k)));
        end
              pipjBpterm =   pipjBpterm +         grupBpprob(j) *grupBpprob(k);
            occsimBpterm = occsimBpterm - sum(abs(grupBpocc(:,j)-grupBpocc(:,k)));
        end
              pipjCpterm =   pipjCpterm +         grupCpprob(j) *grupCpprob(k);
            occsimCpterm = occsimCpterm - sum(abs(grupCpocc(:,j)-grupCpocc(:,k)));
    end
    end

    diff =b1*( (  pipjAterm-  pipjApterm)/(numA-1) + (  pipjBterm-  pipjBpterm)/(numB-1) + (  pipjCterm-  pipjCpterm)/(numC-1) ) + ...
          b2*( (occsimAterm-occsimApterm)/(numA-1) + (occsimBterm-occsimBpterm)/(numB-1) + (occsimCterm-occsimCpterm)/(numC-1) );

    if diff > little
        if byvil
            if only2gp
                count = count + 1/combs2gp;
            else
                count = count + 1/combs;
            end
        else
            count = count + 1;
        end
    end
    if byvil
        if only2gp
            counttotal = counttotal + 1/combs2gp;
        else
            counttotal = counttotal + 1/combs;
        end
    else
        counttotal = counttotal + 1;
    end


end
end
end

counttotal
val=-count;