function F=fract2(vecs)
% Get Fractionalization index.

[total cols] = size(vecs);
warning off;
F = zeros(1,cols)/0;
warning on;

for j=1:cols
    v = vecs(:,j);
    unq = unique(v);
    sumsq=0;
    for k=1:length(unq)
        sumsq = sumsq + (sum(v==unq(k)))^2;
    end
    F(1,j) = 1 - sumsq/total^2;
end