function c=getcatineq(data,datareports,villagenums,twogrups,stats,permprog,numdata,equalerr,catgs)

[rows,cols,numcatgs]=size(data);
if numcatgs ~= length(catgs)
    error('Data and categories mismatched.');
end

mindata =2;   
numpair = sum(twogrups)/2 +1;
numstats = length(find(stats));
warning off;
results = zeros(numpair,numdata*numstats)/0;
village = zeros(numpair,1)/0;
warning on;

k=1;
pair=1;
while k<=rows
    % This segment reshapes the data to have individuals on rows and
    % categories on columns
    if twogrups(k)==1 || villagenums(k)==492624543
    if twogrups(k)==1
        numa = datareports(k);
        numb = datareports(k+1);
        grupnums = [numa; numb];
        datagrupa = reshape(data(k  ,1:numa,:),numa,numcatgs,1);
        datagrupb = reshape(data(k+1,1:numb,:),numb,numcatgs,1);
        datatotal = [datagrupa; datagrupb];
        datatotal = equalerr*round(datatotal/equalerr);
    elseif villagenums(k)==492624543
        numa = datareports(k);
        numb = datareports(k+1);
        numc = datareports(k+2);
        grupnums = [numa; numb; numc];
        datagrupa = reshape(data(k  ,1:numa,:),numa,numcatgs,1);
        datagrupb = reshape(data(k+1,1:numb,:),numb,numcatgs,1);
        datagrupc = reshape(data(k+2,1:numc,:),numc,numcatgs,1);
        datatotal = [datagrupa; datagrupb; datagrupc];
        datatotal = equalerr*round(datatotal/equalerr);
    else error('Something off.');
    end

    % This segment drops any individual with a zero reading in every
    % category, which leads to NaN entries, and alone leads to them.
    indicesdrop = [];
    for j=1:sum(grupnums)
        if sum(isnan(datatotal(j,:)))
            indicesdrop = [indicesdrop; j];
            grupindex = 1 + (j>numa) + (j>numa+numb);
            grupnums(grupindex)=grupnums(grupindex)-1;
        end
    end
    datatotal(indicesdrop,:)=[];

    % This segment checks whether this is an identical village
    identical = 1;
    j=1;
    while identical && j<sum(grupnums)
        identical = ( sum( abs(datatotal(j,:)-datatotal(j+1,:)) ) == 0);
        j=j+1;
    end

    if min(grupnums)>=mindata && ~identical
        thisresult=computecatineq(datatotal,grupnums,stats,catgs);
command = ['thiscompare = ' permprog '(datatotal,grupnums,thisresult,stats,equalerr,catgs);'];
        eval(command);

        results(pair,1:numdata*numstats) = reshape([thisresult thiscompare]',1,numdata*numstats);
%        results(pair,1:numdata*numstats)
    end
    village(pair) = villagenums(k);
    if twogrups(k)==1
        k=k+2;
    elseif villagenums(k)==492624543
        k=k+3;
        pair3 = pair;
    end
    pair=pair+1;
    else
        k=k+1;
    end
end

%error('test over');

c= [results village];

line3 = c(pair3,:);
c(pair3,:) = [];
c= [c; line3];