function c=getrbstdumwt(data,grupnums,trueresult,stats,equalerr)
% robust calculation with percentile 
numtotal = sum(grupnums);
numgrups = length(grupnums);
numstats = length(find(stats));

count_total = nchoosek(numtotal, grupnums(1));
if numgrups == 3
    numresid = numtotal-grupnums(1);
    count_total = count_total * nchoosek( numresid, grupnums(2));
end

warning off;
countsmall  =zeros(numstats,1);
countgreat  =zeros(numstats,1);
countequal  =zeros(numstats,1)/0;
hyporesults =zeros(numstats,count_total)/0;
warning on;

cnt = 0;
for j=1:(2^numtotal-1)
    p1 = bitget(j,numtotal:-1:1)';
    if (sum(p1)==grupnums(1))
        [pos1 junk] = find(p1);
        hypogrupa = data(pos1,:);
        [poso junk] = find(1-p1);
        otherdata = data(poso,:);
            
        if numgrups == 2
            hypogrupb = otherdata;
            hypototal = [hypogrupa; hypogrupb];
            hyporesult = geteq3(hypototal,grupnums,stats);
            
%{
            if ~min((hyporesult < trueresult) == (hyporesult +equalerr < trueresult)) | ...
               ~min((hyporesult > trueresult) == (hyporesult -equalerr > trueresult))
                hypototal
                hyporesult
                trueresult
                dif = hyporesult(5)-trueresult(5)
                (hyporesult < trueresult)
                (hyporesult +equalerr < trueresult)
                (hyporesult > trueresult)
                (hyporesult -equalerr > trueresult)
            end
%}            
%{            
            if length(unique(hyporesult < trueresult-equalerr))>1 || length(unique(hyporesult > trueresult+equalerr))>1
                hypototal
                hyporesult
                trueresult
                hyporesult-trueresult
            end
%}           
            
            countsmall = countsmall+ (hyporesult < trueresult-equalerr);
            countgreat = countgreat+ (hyporesult > trueresult+equalerr);
            cnt = cnt+1; hyporesults(:,cnt) = hyporesult;
            
        elseif numgrups == 3
            for k=1:(2^numresid-1)
                p2 = bitget(k,numresid:-1:1)';
                if (sum(p2)==grupnums(2))
                    [pos2 junk] = find(p2);
                    hypogrupb = otherdata(pos2,:);
                    [pos3 junk] = find(1-p2);
                    hypogrupc = otherdata(pos3,:);
                    hypototal = [hypogrupa;hypogrupb;hypogrupc];
                    hyporesult= geteq3(hypototal,grupnums,stats);
                    countsmall = countsmall+ (hyporesult < trueresult-equalerr);
                    countgreat = countgreat+ (hyporesult > trueresult+equalerr);
                    cnt = cnt+1; hyporesults(:,cnt) = hyporesult;
                end
            end
        end
    end        
end

countequal = count_total-countsmall-countgreat;
c=[countsmall countequal countgreat]/count_total;


if cnt~=count_total
    error('Something amiss in getrbstdumwt');
end
fractcombs = (fract2(hyporesults'))';
minvals = min(hyporesults,[],2);
avgvals = mean(hyporesults,2);
maxvals = max(hyporesults,[],2);
atminval = sum(hyporesults<minvals+equalerr,2)/count_total;
atmaxval = sum(hyporesults>maxvals-equalerr,2)/count_total;

c = [c fractcombs minvals avgvals maxvals atminval atmaxval];